package AllCategorySelector::CMS;

use strict;

sub add_flag {
    my ($cb, $app, $template) = @_;

    my $q = $app->param;
    return if $q->param('_type') eq 'page';

    my $plugin = MT->component("AllCategorySelector");
    return if !$plugin->get_config_value('use_plugin', 'blog:'.$app->blog->id);

    my $message = $plugin->translate('select all');

    my $old = <<HTML;
<div class="category-selector-header">
HTML
    $old = quotemeta($old);

    my $new = <<HTML;
<div class="category-selector-header">
<span><input type="checkbox" id="category-selector-all" />  <label id="category-selector-all-label" for="category-selector-all">$message</label></span>
HTML
    $$template =~ s/$old/$new/;
}

sub add_script {
    my ($cb, $app, $template) = @_;

    my $q = $app->param;
    return if $q->param('_type') eq 'page';

    my $plugin = MT->component("AllCategorySelector");
    return if !$plugin->get_config_value('use_plugin', 'blog:'.$app->blog->id);

    my $old = <<HTML;
<mt:include name="include/footer.tmpl" id="footer_include">
HTML
    $old = quotemeta($old);

    my $plugin = MT->component("AllCategorySelector");
    return if !$plugin->get_config_value('use_plugin', 'blog:'.$app->blog->id);

    my $primary_category_id = $plugin->get_config_value('primary_category_id', 'blog:'.$app->blog->id);
    my $select_message = $plugin->translate('select all');
    my $clear_message = $plugin->translate('clear all');

    my $new = <<HTML;
<mt:include name="include/footer.tmpl" id="footer_include">
<style type="text/css">
.category-selector-header span {
    float: left;
}
</style>
<script type="text/javascript">
/* <![CDATA[ */
jQuery(function() {
    var primary = '$primary_category_id';
    var selectMessage = '$select_message';
    var clearMessage = '$clear_message';
    jQuery("#category-selector-all").change(function(){
        var data = jQuery(this).attr('checked');
        var list = new Array(); 
        if (data) {
            jQuery('.add-category-checkbox').each(function (){
                jQuery(this).attr('checked','checked');
                var name = jQuery(this).attr('name');
                var cat_id = name.replace(/add_category_id_(.*)/,'\$1');
                if ( primary && primary == cat_id ) {
                    list.unshift(cat_id);
                } else {
                    list[list.length] = cat_id;
                }
            });
            MT.App.selectedCategoryList = Array.fromPseudo( list );
            app.categorySelector.list.setSelection( MT.App.selectedCategoryList );
            app.catList.redraw();
            jQuery('#category-selector-list .list-item').addClass('selected');
            jQuery('#category-selector-all-label').text(clearMessage);
        } else {
            jQuery('.add-category-checkbox').each(function (){
                jQuery(this).removeAttr('checked');
            });
            MT.App.selectedCategoryList = [];
            app.catList.redraw();
            jQuery('#category-selector-list .list-item').removeClass('selected');
            jQuery('#category-selector-all-label').text(selectMessage);
        }
    });

    // no work
    jQuery('#open-category-selector1').click(function(){
        jQuery('.list-item').each(function(){
            if (jQuery(this).hasClass('selected')) {
                counter++;
            }
        });
        if (counter) {
//            jQuery("#category-selector-all").attr('checked', 'checked');
        }
    });

//    setTimeout("checkChecked()", 1000);

});

function checkChecked() {
    var counter = 0;
    jQuery('.list-item').each(function(){
        if (jQuery(this).hasClass('selected')) {
            counter++;
        }
    });
    if (counter) {
        jQuery("#category-selector-all").attr('checked', 'checked');
    }
}
/* ]]> */
</script>
HTML
    $$template =~ s/$old/$new/;
}

1;
